//  tpr - VanHeuvelen & Long (tvanheuv@indiana.edu) | 2013-09-29
//  creeate sampling pling variables

program define tpr_pop_sampling

    version 13
    tempvar u1 u2
    qui {
        gen double `u1' = .
        gen double `u2' = .
        local nsamplebase = $nsamples
        local samplesizes $samplesmallest $samplesother
        foreach sampn of numlist `samplesizes' {
            nois di _new "Generating samples of size `sampn': "
            if (`sampn'==50) global nsamples = `nsamplebase'*$n50factor
            else if (`sampn'==100) global nsamples = `nsamplebase'*$n100factor
            else global nsamples = `nsamplebase'
            forvalues isamp = 1/$nsamples {
                replace `u1' = runiform()
                replace `u2' = runiform()
                sort `u1' `u2' // see the Stata blog for rationale
                gen byte s`sampn'i`isamp' = _n<=`sampn'
                label var  s`sampn'i`isamp' "n=`sampn' #`isamp'"
                local dotit = mod(`isamp',100)==0
                nois if `dotit' noi di _continue ".`isamp'"
            }
        }
    }

end
exit