//  tpr - VanHeuvelen & Long (tvanheuv@indiana.edu) | 2013-09-29
//  save dataset with characteristics

program define tpr_pop_savedta

    version 13

    local popdta    tpr-$popdta-pop.dta
    local samplesizes $samplesmallest $samplesother

    char _dta[author] $author
    char _dta[created] $date
    char _dta[title] $title
    char _dta[pop_pgm] $pgm
    char _dta[pop_dta] $popdta

    char _dta[pop_nobs] $nobs
    char _dta[pop_seed] $seed
    char _dta[pop_b0] $b0
    forvalues ib = 1/$rhsN {
        char _dta[pop_b`ib'] $b`ib'
        char _dta[pop_best`ib'] $best`ib'
        char _dta[pop_bse`ib'] $bse`ib'
    }
    local catsNm1 = $catsN - 1
    forvalues icut = 1/`catsNm1' {
        char _dta[pop_bcut`icut'] $bcut`icut''
    }

    char _dta[y_name] $lhsnm
    char _dta[y_catsN] $catsN
    char _dta[rhsN] $rhsN
    char _dta[rhsnms] $rhsnms

    forvalues icat = 1/$catsN {
        char _dta[y_cat`icat'pct] $pct`icat'
    }
    char _dta[y_catmin] $pop_ymin
    char _dta[y_catmax] $pop_ymax

    foreach nm in $rhsnms {
        char _dta[`nm'_desc] $`nm'_desc
        char _dta[`nm'_pct1] $`nm'_pct1
        char _dta[`nm'_wtx1] $`nm'_wtx1
        char _dta[`nm'_wtx2] $`nm'_wtx2
        char _dta[`nm'_wtnormal] $`nm'_wtnormal
        char _dta[`nm'_wtchi] $`nm'_wtchi
        char _dta[`nm'_wtskew] $`nm'_wtskew
    }
    char _dta[ydist_pop] $y_dist

    char _dta[nreplications] $nreplications
    char _dta[samplesmallest] $samplesmallest
    char _dta[samplesizes] `samplesizes'
    char _dta[samplesN] $nsamples

    char _dta[n100factor] $n100factor
    char _dta[n50factor] $n50factor
    char _dta[nonconvergefactor] $nonconvergefactor
    char _dta[trimsdlimit] $trimsdlimit

    //  save population data

    aorder
    order id ycat ystar x* e
    qui compress
    datasignature set, reset
    label data "$popdta | $poppgm.do $author $popdate'."
    note _dta: $popdta | $poppgm.do $author $popdate'.
    saveold $popdta, replace

end
exit